
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《深入理解Nginx：模块开发与架构解析》一3.4　HTTP模块的数据结构 / iVAN</title>

    <meta name="description" content="《深入理解Nginx：模块开发与架构解析》一3.4　HTTP模块的数据结构 3.4 HTTP模块的数据结构 定义HTTP模块方式很简单,例如: ngx_module_t ngx_http_mytest_module; 其中,ngx_module_t 是一个Nginx模块的数据结构(详见8.2节).下面来分析一下Nginx模块中所有的成员,如下所示: typedef struct ngx_module_s ngx_module_t; struct ngx_module_s { /* 下面的ctx_index.index.spare0.spare1.spare2.spare">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《深入理解Nginx：模块开发与架构解析》一3.4　HTTP模块的数据结构</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>3.4　HTTP模块的数据结构</h3>
<p>定义HTTP模块方式很简单，例如：</p>
<pre><code>ngx_module_t ngx_http_mytest_module;
</code></pre>
<p>其中，ngx_module_t 是一个Nginx模块的数据结构（详见8.2节）。下面来分析一下Nginx模块中所有的成员，如下所示：</p>
<pre><code>typedef struct ngx_module_s      ngx_module_t;
struct ngx_module_s {
</code></pre>
<pre><code> /* 下面的ctx_index、index、spare0、spare1、spare2、spare3、version变量不需要在定义时赋值，可以用Nginx准备好的宏NGX_MODULE_V1来定义，它已经定义好了这7个值。
#define NGX_MODULE_V1          0, 0, 0, 0, 0, 0, 1
</code></pre>
<pre><code>对于一类模块（由下面的type成员决定类别）而言，ctx_index表示当前模块在这类模块中的序号。这个成员常常是由管理这类模块的一个Nginx核心模块设置的，对于所有的HTTP模块而言，ctx_index是由核心模块ngx_http_module设置的。ctx_index非常重要，Nginx的模块化设计非常依赖于各个模块的顺序，它们既用于表达优先级，也用于表明每个模块的位置，借以帮助Nginx框架快速获得某个模块的数据（HTTP框架设置ctx_index的过程参见10.7节）*/
</code></pre>
<pre><code>ngx_uint_t            ctx_index;

</code></pre>
<pre><code>/*index表示当前模块在ngx_modules数组中的序号。注意，ctx_index表示的是当前模块在一类模块中的序号，而index表示当前模块在所有模块中的序号，它同样关键。Nginx启动时会根据ngx_modules数组设置各模块的index值。例如：
ngx_max_module = 0;
for (i = 0; ngx_modules[i]; i++) {
    ngx_modules[i]-&gt;index = ngx_max_module++;
}
*/
    ngx_uint_t            index;

    //spare系列的保留变量，暂未使用
    ngx_uint_t            spare0;
    ngx_uint_t            spare1;
    ngx_uint_t            spare2;
    ngx_uint_t            spare3;
    //模块的版本，便于将来的扩展。目前只有一种，默认为1
    ngx_uint_t            version;

    /<em>ctx用于指向一类模块的上下文结构体，为什么需要ctx呢？因为前面说过，Nginx模块有许多种类，不同类模块之间的功能差别很大。例如，事件类型的模块主要处理I/O事件相关的功能，HTTP类型的模块主要处理HTTP应用层的功能。这样，每个模块都有了自己的特性，而ctx将会指向特定类型模块的公共接口。例如，在HTTP模块中，ctx需要指向ngx_http_module_t结构体</em>/
    void                 *ctx;

    //commands将处理nginx.conf中的配置项，详见第4章
    ngx_command_t        *commands;

    /<em>type表示该模块的类型，它与ctx指针是紧密相关的。在官方Nginx中，它的取值范围是以下5种：NGX_HTTP_MODULE、NGX_CORE_MODULE、NGX_CONF_MODULE、NGX_EVENT_MODULE、NGX_MAIL_MODULE。这5种模块间的关系参考图8-2。实际上，还可以自定义新的模块类型</em>/
    ngx_uint_t            type;

    /<em>在Nginx的启动、停止过程中，以下7个函数指针表示有7个执行点会分别调用这7种方法（参见8.4节～8.6节）。对于任一个方法而言，如果不需要Nginx在某个时刻执行它，那么简单地把它设为NULL空指针即可</em>/

    /<em>虽然从字面上理解应当在master进程启动时回调init_master，但到目前为止，框架代码从来不会调用它，因此，可将init_master设为NULL </em>/
    ngx_int_t           (<em>init_master)(ngx_log_t </em>log);
    /<em>init_module回调方法在初始化所有模块时被调用。在master/worker模式下，这个阶段将在启动worker子进程前完成</em>/
    ngx_int_t           (<em>init_module)(ngx_cycle_t </em>cycle);
/<em> init_process回调方法在正常服务前被调用。在master/worker模式下，多个worker子进程已经产生，在每个worker进程的初始化过程会调用所有模块的init_process函数</em>/
    ngx_int_t           (<em>init_process)(ngx_cycle_t </em>cycle);
/<em> 由于Nginx暂不支持多线程模式，所以init_thread在框架代码中没有被调用过，设为NULL</em>/
    ngx_int_t           (<em>init_thread)(ngx_cycle_t </em>cycle);
// 同上，exit_thread也不支持，设为NULL
    void                (<em>exit_thread)(ngx_cycle_t </em>cycle);
/<em> exit_process回调方法在服务停止前调用。在master/worker模式下，worker进程会在退出前调用它</em>/
    void                (<em>exit_process)(ngx_cycle_t </em>cycle);
// exit_master回调方法将在master进程退出前被调用
    void                (<em>exit_master)(ngx_cycle_t </em>cycle);

    /<em>以下8个spare_hook变量也是保留字段，目前没有使用，但可用Nginx提供的NGX_MODULE_V1_PADDING宏来填充。看一下该宏的定义：#define NGX_MODULE_V1_PADDING  0, 0, 0, 0, 0, 0, 0, 0</em>/
    uintptr_t             spare_hook0;
    uintptr_t             spare_hook1;
    uintptr_t             spare_hook2;
    uintptr_t             spare_hook3;
    uintptr_t             spare_hook4;
    uintptr_t             spare_hook5;
    uintptr_t             spare_hook6;
    uintptr_t             spare_hook7;
};

</code></pre>
<p>定义一个HTTP模块时，务必把type字段设为NGX_HTTP_MODULE。<br />
对于下列回调方法：init_module、init_process、exit_process、exit_master，调用它们的是Nginx的框架代码。换句话说，这4个回调方法与HTTP框架无关，即使nginx.conf中没有配置http {...}这种开启HTTP功能的配置项，这些回调方法仍然会被调用。因此，通常开发HTTP模块时都把它们设为NULL空指针。这样，当Nginx不作为Web服务器使用时，不会执行HTTP模块的任何代码。<br />
定义HTTP模块时，最重要的是要设置ctx和commands这两个成员。对于HTTP类型的模块来说，ngx_module_t中的ctx指针必须指向ngx_http_module_t接口（HTTP框架的要求）。下面先来分析ngx_http_module_t结构体的成员。<br />
HTTP框架在读取、重载配置文件时定义了由ngx_http_module_t接口描述的8个阶段，HTTP框架在启动过程中会在每个阶段中调用ngx_http_module_t中相应的方法。当然，如果ngx_http_module_t中的某个回调方法设为NULL空指针，那么HTTP框架是不会调用它的。</p>
<pre><code>typedef struct {
    //解析配置文件前调用
    ngx_int_t   (<em>preconfiguration)(ngx_conf_t </em>cf);
    //完成配置文件的解析后调用
    ngx_int_t   (<em>postconfiguration)(ngx_conf_t </em>cf);

    /<em>当需要创建数据结构用于存储main级别（直属于http{...}块的配置项）的全局配置项时，可以通过create_main_conf回调方法创建存储全局配置项的结构体</em>/
    void       <em>(</em>create_main_conf)(ngx_conf_t *cf);
    //常用于初始化main级别配置项
    char       <em>(</em>init_main_conf)(ngx_conf_t <em>cf, void </em>conf);

    /<em>当需要创建数据结构用于存储srv级别（直属于虚拟主机server{...}块的配置项）的配置项时，可以通过实现create_srv_conf回调方法创建存储srv级别配置项的结构体</em>/
    void       <em>(</em>create_srv_conf)(ngx_conf_t *cf);
    // merge_srv_conf回调方法主要用于合并main级别和srv级别下的同名配置项
    char       <em>(</em>merge_srv_conf)(ngx_conf_t <em>cf, void </em>prev, void *conf);

    /<em>当需要创建数据结构用于存储loc级别（直属于location{...}块的配置项）的配置项时，可以实现create_loc_conf回调方法</em>/
    void       <em>(</em>create_loc_conf)(ngx_conf_t *cf);
    // merge_loc_conf回调方法主要用于合并srv级别和loc级别下的同名配置项
    char       <em>(</em>merge_loc_conf)(ngx_conf_t <em>cf, void </em>prev, void *conf);
} ngx_http_module_t;

</code></pre>
<p>不过，这8个阶段的调用顺序与上述定义的顺序是不同的。在Nginx启动过程中，HTTP框架调用这些回调方法的实际顺序有可能是这样的（与nginx.conf配置项有关）：</p>
<pre><code>1）create_main_conf
2）create_srv_conf
3）create_loc_conf
4）preconfiguration
5）init_main_conf
6）merge_srv_conf
7）merge_loc_conf
8）postconfiguration

</code></pre>
<p>commands数组用于定义模块的配置文件参数，每一个数组元素都是ngx_command_t类型，数组的结尾用ngx_null_command表示。Nginx在解析配置文件中的一个配置项时首先会遍历所有的模块，对于每一个模块而言，即通过遍历commands数组进行，另外，在数组中检查到ngx_null_command时，会停止使用当前模块解析该配置项。每一个ngx_command_t结构体定义了自己感兴趣的一个配置项：</p>
<pre><code>typedef struct ngx_command_s     ngx_command_t;
struct ngx_command_s {
    //配置项名称，如"gzip"
    ngx_str_t             name;
    /*配置项类型，type将指定配置项可以出现的位置。例如，出现在server{}或location{}中，以及它可以携带的参数个数*/
    ngx_uint_t            type;
    //出现了name中指定的配置项后，将会调用set方法处理配置项的参数
    char               *(*set)(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
    //在配置文件中的偏移量
    ngx_uint_t            conf;
    /*通常用于使用预设的解析方法解析配置项，这是配置模块的一个优秀设计。它需要与conf配合使用，在第4章中详细介绍*/
    ngx_uint_t            offset;
    //配置项读取后的处理方法，必须是ngx_conf_post_t结构的指针
    void                 *post;
};
ngx_null_command只是一个空的ngx_command_t，如下所示：
#define ngx_null_command  { ngx_null_string, 0, NULL, 0, 0, NULL }
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 13:36:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/index/" title="index">index</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/nginx/" title="nginx">nginx</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《深入理解Nginx：模块开发与架构解析》一3.4　HTTP模块的数据结构的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYBD7Vp.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一第3章　开发一个简单的HTTP模块 3&period;0</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第3章 开发一个简单的HTTP模块 当通过开发HTTP模块来实现产品功能时,是可以完全享用Nginx的优秀设计所带来的.与官方模块相同的高并发特性的.不过,如何开发一个充满异步调用.无阻塞的HTTP模块呢?首先,需要把程序嵌入到Nginx中,也就是说,最终编译出的二进制程序Nginx要包含我们的代码(见3.3节):其次,这个全新的HTTP模块要能介入到HTTP请求的处理流程中(具体参见3.1节.3.4节.3.5节).满足上述两个前提后,我们的模块才能开始处理HTTP请求,但在开始处理请求前还需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NNeyM.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一1&period;5　configure详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 configure详解 可以看出,configure命令至关重要,下文将详细介绍如何使用configure命令,并分析configure到底是如何工作的,从中我们也可以看出Nginx的一些设计思想. 1.5.1 configure的命令参数 使用help命令可以查看configure包含的参数. ./configure --help 这里不一一列出help的结果,只是把它的参数分为了四大类型,下面将会详述各类型下所有参数的用法和意义. 1. 路径相关的参数 表1-2列出了Nginx在编译			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB112kz.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一2&period;3　Nginx服务的基本配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 Nginx服务的基本配置 Nginx在运行时,至少必须加载几个核心模块和一个事件类模块.这些模块运行时所支持的配置项称为基本配置-所有其他模块执行时都依赖的配置项. 下面详述基本配置项的用法.由于配置项较多,所以把它们按照用户使用时的预期功能分成了以下4类: 用于调试.定位问题的配置项. 正常运行的必备配置项. 优化性能的配置项. 事件类配置项(有些事件类配置项归纳到优化性能类,这是因为它们虽然也属于events {}块,但作用是优化性能). 有这么一些配置项,即使没有显式地进行配置,它			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAA9mXM.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一3&period;9　用C&plus;&plus;语言编写HTTP模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.9 用C++语言编写HTTP模块 Nginx及其官方模块都是由C语言开发的,那么能不能使用C++语言来开发Nginx模块呢?C语言是面向过程的编程语言,C++则是面向对象的编程语言,面向对象与面向过程的优劣这里暂且不论,存在即合理.当我们由于各种原因需要使用C++语言实现一个Nginx模块时(例如,某个子功能是用C++语言写成,或者开发团队对C++语言更熟练,又或者就是喜欢使用C++语言),尽管Nginx本身并没有提供相应的方法支持这样做,但由于C语言与C++语言的近亲特性,我们还是可以比较			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmVkOlz.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一3&period;3　如何将自己的HTTP模块编译进Nginx</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.3 如何将自己的HTTP模块编译进Nginx Nginx提供了一种简单的方式将第三方的模块编译到Nginx中.首先把源代码文件全部放到一个目录下,同时在该目录中编写一个文件用于通知Nginx如何编译本模块,这个文件名必须为config.它的格式将在3.3.1节中说明.这样,只要在configure脚本执行时加入参数--add-module=PATH(PATH就是上面我们给定的源代码.config文件的保存目录),就可以在执行正常编译安装流程时完成Nginx编译工作.有时,Nginx提供的这种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmkrxz.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一3&period;5　定义自己的HTTP模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.5 定义自己的HTTP模块 上文中我们了解了定义HTTP模块时需要定义哪些成员以及实现哪些方法,但在定义HTTP模块前,首先需要确定自定义的模块应当在什么样的场景下开始处理用户请求,也就是说,先要弄清楚我们的模块是如何介入到Nginx处理用户请求的流程中的.从2.4节中的HTTP配置项意义可知,一个HTTP请求会被许多个配置项控制,实际上这是因为一个HTTP请求可以被许多个HTTP模块同时处理.这样一来,肯定会有一个先后问题,也就是说,谁先处理请求谁的&quot;权力&quot;就更大.例如,ngx_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWk1Gz.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一2&period;2　Nginx配置的通用语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 Nginx配置的通用语法 Nginx的配置文件其实是一个普通的文本文件.下面来看一个简单的例子. user nobody; worker_processes 8; error_log /var/log/nginx/error.log error; #pid logs/nginx.pid; events { use epoll; worker_connections 50000; } http { include mime.types; default_type application/o			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mqg1GRz.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一1&period;2　为什么选择Nginx</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 为什么选择Nginx 为什么选择Nginx?因为它具有以下特点:(1)更快这表现在两个方面:一方面,在正常情况下,单次请求会得到更快的响应:另一方面,在高峰期(如有数以万计的并发请求),Nginx可以比其他Web服务器更快地响应请求.实际上,本书第三部分中大量的篇幅都是在说明Nginx是如何做到这两点的.(2)高扩展性Nginx的设计极具扩展性,它完全是由多个不同功能.不同层次.不同类型且耦合度极低的模块组成.因此,当对某一个模块修复Bug或进行升级时,可以专注于模块自身,无须在意其他.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlxQqb.html" rel="bookmark">《深入理解Nginx：模块开发与架构解析》一1&period;3　准备工作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 准备工作 由于Linux具有免费.使用广泛.商业支持越来越完善等特点,本书将主要针对Linux上运行的Nginx来进行介绍.需要说明的是,本书不是使用手册,而是介绍Nginx作为Web服务器的设计思想,以及如何更有效地使用Nginx达成目的,而这些内容在各操作系统上基本是相通的(除了第9章关于事件驱动方式以及第14章的进程间同步方式在类UNIX操作系统上略有不同以外). 1.3.1 Linux操作系统 首先我们需要一个内核为Linux 2.6及以上版本的操作系统,因为Linux 2.6及			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDkYlp.html" rel="bookmark" class="title">建立可扩展的silverlight应用框架 step-7 final</a>
					<div>
						前六节的文章已经完全的记录这个项目的开发过程,其中第5节和第6节相隔的时间比较长 ,这期间我翻阅了大量的Prism官方文档以及网络上的资料,其实第6节的内容是很深.很连 贯的,以至于无法在一节里写完所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Y3aM.html" rel="bookmark" class="title">曾育文：排名下降很忧伤 应对方法需五招</a>
					<div>
						大家好,我是曾育文,虽然今天是周末,但是自己过的也并不轻松,因为发现自己网站的关键词排名掉了,既然排名掉了,玩的心肯定没了,分析排名下降的原因是关键,于是对网站的各方面进行了一个比较细心的分析,发现关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKDndM.html" rel="bookmark" class="title">ajax框架之dojo篇（一）</a>
					<div>
						一.do对象的函数 1) dojo.byId(id) &lt;input type=&quot;text&quot; id=&quot;txtId&quot; size=&quot;30&quot;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Nom3z.html" rel="bookmark" class="title">ORA-00604问题的解决方法</a>
					<div>
						客户遇到个问题,描述如下:--环境是ORACLE 9.2.0.8 (语句及场景非真实了,网上找的,情况是一致的) 创建了一个DB_LINK连接另一个Oracle数据库. select * from t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyLQqb.html" rel="bookmark" class="title">Linux系统kernel参数传递方式详解</a>
					<div>
						ARM体系结构: 1．最常用的方式,就是在make config里修改&quot;General Setup&quot;子菜单中的&quot;Default kernel command string ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91qyKM.html" rel="bookmark" class="title">利用Amazon Web Services集成企业应用程序</a>
					<div>
						队列 是用于存储等待处理的消息的临时数据结构.Amazon Simple Queue Services (Amazon SQS) 是一个支持 Web 服务的高可用性可伸缩消息队列.Amazon SQS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2Y09p.html" rel="bookmark" class="title">asp 多表联合查询语句</a>
					<div>
						 A表: VENID  VENNAME 0001   公司1 0002   公司2 B表: DOCNO     VENID    CDATE 20090001   0001    2009-01-01 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9158kM.html" rel="bookmark" class="title">PhotoShop绘制一个红色古典花瓶</a>
					<div>
						本教程主要应用钢笔工具结加深.减淡工具的运用,绘制一个古典花瓶,是老教程了,喜欢的同学可以跟着练习,多练习才会有进步. 终极效果图: 第一步:新建一个画布,画布的尺寸设成500*800,单位当然是像素 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3q6jp.html" rel="bookmark" class="title">PS根据人物头像绘制夸张漫画效果</a>
					<div>
						  绘制漫画需要较强的美术功底,因为漫画不同于写实风格画,需要更多的抽象思维,抓住人物图像的一些特性,用夸张的手法表现出来. 最终效果 1.打个草稿: 因为不是凭空想的,所以绘画之前需要一张人像照片, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywWNkz.html" rel="bookmark" class="title">linux中bash&colon; service&colon; command not found 错误</a>
					<div>
						  今天在进行linux操作的时候,要对vsftpd服务进行重启,使用service vsftpd restart,此时报了一个难以让人相信的错误: bash: service: command no ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYyQBb.html" rel="bookmark" class="title">巧用photoshop后期合成蒙太奇海报效果</a>
					<div>
						  巧用photoshop后期合成蒙太奇海报效果,表达神秘.梦幻.科幻感,素材拼图痕迹地融合一起,实用的调色技巧的运用,有兴趣的童鞋们 分类: PS图片处理 ps后期处理教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZaR3b.html" rel="bookmark" class="title">如何解决Windows7&OpenCurlyDoubleQuote;错误16389，无法新建库&rdquo;的问题</a>
					<div>
						可是有同学反映,新建库的时候,系统弹出错误信息&quot;无法创建文件 '新建 库.library-ms'文件系统错误(16389)&quot; 无法创建库?? 不要着急,这个可能是相关权限被限制了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq814Ob.html" rel="bookmark" class="title">给力助手怎么设置按键</a>
					<div>
						  给力助手设置按键教程: 首先我们可以在给力助手&quot;应用管理&quot;界面中找到&quot;按键大师&quot;,点击就会弹出安卓模拟器按键大师的软件操作界面,其各项功能如下图: 在蓝手指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGkv5p.html" rel="bookmark" class="title">visual studio-小白来提问，关于VS和VC的不同</a>
					<div>
						问题描述 小白来提问,关于VS和VC的不同 本小白用的是VS2013,只在大学期间用过VC,我的疑问是:是不是在类似于VC++2012里面主函数末尾不用加类似于while(1)或者getchar(), ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YX2ZM.html" rel="bookmark" class="title">iOS 中由谓词引发的正则血案正在破案中</a>
					<div>
						iOS 中由谓词引发的正则血案正在破案中 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创作公用协议  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPaq1p.html" rel="bookmark" class="title">刘强东在微博上表示，将在第三、四季度掀起史上最强价格战，并且将在月底推出具体措施</a>
					<div>
						刘强东微博称:&quot;今天早会上和全国经理们说:今年第三.四季度会掀起http://www.aliyun.com/zixun/aggregation/1459.html&quot; style=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE62DLM.html" rel="bookmark" class="title">显示-struts的radio标签中list属性有多个值怎样回显选中的值</a>
					<div>
						问题描述 struts的radio标签中list属性有多个值怎样回显选中的值 表单代码: &lt;td&gt;&lt;s:radio list=&quot;#{'0':'AA','1':'BB','2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQG9Lp.html" rel="bookmark" class="title">《逆袭大学》文摘&mdash;&mdash;9&period;5 用算法和数学奠定专业基础</a>
					<div>
						有不少读者给我来信,咨询的是关于数学和算法对学习计算机的意义.这样的话题,在我的专栏中很多文章里都提到过.在拙作&lt;逆袭大学--传给IT学子正能量&gt;中,在这方面写了不少文字,现将其中的9.5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEoGop.html" rel="bookmark" class="title">mybatis怎么读取oracle xmltype类型的数据</a>
					<div>
						问题描述 mybatis怎么读取oracle xmltype类型的数据 1.oracle 用的是字段类型是xmltype BOOK_ID NUMBER BOOK_NAME XMLTYPE BOOK_P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2LDmb.html" rel="bookmark" class="title">中顺洁柔陷入一场始料不及的质量风波</a>
					<div>
						洁柔纸巾&quot;超标&quot;风波缘起相关标准&quot;打架&quot;&lt;中国经济周刊&gt; 记者 刘德炳 邹锡兰|广东报道一边是企业自认为一项保湿创新工艺,一边却是被曝光&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0rQnM.html" rel="bookmark" class="title">《Arduino开发实战指南：机器人卷》一3&period;5　常用电机驱动芯片介绍</a>
					<div>
						3.5 常用电机驱动芯片介绍 实际应用时,用分立器件制作H桥式直流电机驱动电路比较麻烦,例如,控制不好易烧毁.需加入保护电路等.目前市面上有很多封装好的H桥集成电路,接上电源后,电机和控制信号就可以使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmaE5b.html" rel="bookmark" class="title">《CCNP SWITCH （642-813 ）学习指南》一1&period;1 企业园区网设计概述</a>
					<div>
						1.1 企业园区网设计概述 CCNP SWITCH (642-813 )学习指南 1.1 企业园区网设计概述 Cisco拥有多种企业园区网的设计模型,这些设计模型都是对各类企业网络的抽象与浓缩.不过, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZ2q3p.html" rel="bookmark" class="title">配置 logrotate 的终极指导</a>
					<div>
						一般来说,日志是任何故障排除过程中非常重要的一部分,但这些日志会随着时间增长.在这种情况下,我们需要手动执行日志清理以回收空间,这是一件繁琐的管理任务.为了解决这个问题,我们可以在 Linux 中配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5xwdp.html" rel="bookmark" class="title">hibernate 3 注解，sql2005 自增得不到主键值</a>
					<div>
						问题描述 我使用的是Hibernate3+注解+SQL2005开发系统的.我的POJO是这样配置的&quot;java&quot;packagecom.chinaunicom.pt.domain.en ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgxYKM.html" rel="bookmark" class="title">c&num;扫雷游戏中的爆炸效果</a>
					<div>
						问题描述 c#扫雷游戏中的爆炸效果 扫雷游戏中的连环爆炸怎么做的啊?实在不会,请大神帮忙!!!谢谢- 解决方案 做一个gif动画表示爆炸,用这个http://download.csdn.net/dow ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeEYlM.html" rel="bookmark" class="title">《UX最佳实践：提高用户体验影响力的艺术 》一1&period;9　协作设计大纲的商业影响</a>
					<div>
						1.9 协作设计大纲的商业影响 目前的研究表明,在过去的六年里,最成功的产品都是从撰写一份全面综合的设计大纲开始的.前面提到的&quot;没有时间撰写设计大纲&quot;的障碍并不存在.如果合作撰写一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXYRVb.html" rel="bookmark" class="title">独立服务器租用优势</a>
					<div>
						一般独立服务器租用多用于大型的网站项目.如WEB2.0,网络视频,网络播客.独立服务器作为比虚拟主机更适合自由独立操作的产品,具有哪些特殊功能是大中型企业所需要的呢? 1:独立的操作系统,http.f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ1lkp.html" rel="bookmark" class="title">Visula Basic 6&period;0语言编程项目添加控件的问题</a>
					<div>
						问题描述 Visula Basic 6.0语言编程项目添加控件的问题 VB6.0中添加控件到窗体,已经引用了这个工程,为什么还是提示说ActveX无法创建对象??? 解决方案 你的控件有没有正确注册, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eqlPb.html" rel="bookmark" class="title">亚马逊用户称被客服骗走43万 折射个人信息安全隐忧</a>
					<div>
						近日,一次亚马逊的购物经历,加上一个陌生手机来电,让北京的彭女士一夜之间就损失了40余万元.而这样的事情并不是个案. 如今,网络诈骗已经从电信诈骗蔓延到电商领域,无论是在淘宝.京东还是亚马逊等电商平台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL7AgM.html" rel="bookmark" class="title">百度周三盘后股价大涨7&percnt;</a>
					<div>
						北京时间2月27日凌晨消息,周三盘后,百度发布了2013财年第四季度未经审计财报.报告显示,百度第四季度总营收为人民币95.23亿元(约合15.73亿美元),比去年同期增长50.3%:净利润为人民币2 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
